#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;

int n, d;

vector < int > adj[maxn];
void input()
{
    cin >> n >> d;
    for (int i = 1; i < n; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}

bool state[maxn];
int dp[maxn];

void dfs_state(int v, int p)
{
    dp[v] = 0;
    for (int u : adj[v])
    {
        if (u == p)
            continue;

        dfs_state(u, v);
        if (dp[u] == 0)
            dp[v] = 1;
    }

}
void get_states()
{
    for (int i = 1; i <= n; i ++)
    {
        dfs_state(i, -1);
        state[i] = dp[i];
    }
}

int fp[2][maxn];
int sub[maxn];

const ll mod = 1e9 + 7;

void dfs(int v, int p)
{
    dp[v] = 0;
    sub[v] = 1;
    fp[0][v] = fp[1][v] = 0;

    int cnt_lose = 0, cnt_win = 0;
    for (int u : adj[v])
    {
        if (u == p)
            continue;

        dfs(u, v);
        sub[v] += sub[u];
        if (dp[u] == 0)
        {
            dp[v] = 1;
            cnt_lose ++;
        }
        else
        {
            cnt_win ++;
        }
    }


    if (cnt_lose > 1)
    {
        fp[0][v] = sub[v];
        fp[1][v] = sub[v];
    }
    else
    if (cnt_lose == 1)
    {
        int mx= - 1;
        for (int u : adj[v])
        {
            if (u != p && dp[u] == 0)
                mx = u;
        }

        fp[0][v] = sub[v] - sub[mx] + (sub[mx] - fp[0][mx]);
        fp[1][v] = sub[v] - sub[mx] + (sub[mx] - fp[1][mx]);
    }
    else
    {
        fp[1][v] = 1;

        for (int u : adj[v])
        {
            if (u == p)
                continue;

            fp[0][v] += (sub[u] - fp[0][u]);
            fp[1][v] += (sub[u] - fp[1][u]); 
        }
    }
    

}



void solve_d1()
{
    ll win_states = 0, lose_states = 0;
    for (int i = 1; i <= n; i ++)
        if (state[i] == 1)
            win_states ++;
        else
            lose_states ++;
    ll ways = 0;
    ///for (int i = 1; i <= n; i ++)
    {
        dfs(1, -1);
        ///cout << "vertex " << i << " " << fp[0][i] << " " << fp[1][i] << endl;
        ways = ways + (ll)(fp[0][1]) * win_states + (ll)(fp[1][1]) * lose_states;
        ways %= mod;
    }
    cout << ways << endl;
}
void solve()
{
    input();
    get_states();
    solve_d1();
}
int main()
{
    solve();
    return 0;
}
    

/**
3 1
1 2
2 3
*/