#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 1e5 + 10;

int n, d;

vector < int > adj[maxn];
void input()
{
    cin >> n >> d;
    for (int i = 1; i < n; i ++)
    {
        int v, u;
        cin >> v >> u;
        adj[v].push_back(u);
        adj[u].push_back(v);
    }
}

bool state[maxn];
int dp[maxn];

void dfs_state(int v, int p)
{
    dp[v] = 0;
    for (int u : adj[v])
    {
        if (u == p)
            continue;

        dfs_state(u, v);
        if (dp[u] == 0)
            dp[v] = 1;
    }

}

void trav(int v, int p, int ab)
{
    int new_dp = 0, old_dp = dp[v];
    int cnt_ls = 0;
    for (int u : adj[v])
    {
        if (u == p)
        {
            if (ab == 0)
            {
                cnt_ls ++;
                new_dp = 1;
            }
        }
        else
        {
            if (dp[u] == 0)
            {
                new_dp = 1;
                cnt_ls ++;
            }
        }
    }

    state[v] = new_dp;
    for (int u : adj[v])
    {
        if (u == p)
            continue;

        int lf = cnt_ls - (dp[u] == 0);
        trav(u, v, (lf > 0));
    }


}
void get_states()
{
    dfs_state(1, -1);
    trav(1, -1, 0);

}

int fp[2][maxn];
int sub[maxn];

const ll mod = 1e9 + 7;

void dfs(int v, int p)
{
    dp[v] = 0;
    sub[v] = 1;
    fp[0][v] = fp[1][v] = 0;

    int cnt_lose = 0, cnt_win = 0;
    for (int u : adj[v])
    {
        if (u == p)
            continue;

        dfs(u, v);
        sub[v] += sub[u];
        if (dp[u] == 0)
        {
            dp[v] = 1;
            cnt_lose ++;
        }
        else
        {
            cnt_win ++;
        }
    }


    if (cnt_lose > 1)
    {
        fp[0][v] = sub[v];
        fp[1][v] = sub[v];
    }
    else
    if (cnt_lose == 1)
    {
        int mx= - 1;
        for (int u : adj[v])
        {
            if (u != p && dp[u] == 0)
                mx = u;
        }

        fp[0][v] = sub[v] - fp[0][mx];
        fp[1][v] = sub[v] - fp[1][mx];
    }
    else
    {
        fp[1][v] = 1;

        for (int u : adj[v])
        {
            if (u == p)
                continue;

            fp[0][v] += (sub[u] - fp[0][u]);
            fp[1][v] += (sub[u] - fp[1][u]); 
        }
    }
    

}

ll prec[2][maxn];
void euler(int v, int p)
{
    //cout << "euler " << v << " " << p << endl;
    //cout << "current " << dp[v] << " " << fp[0][v] << " " << fp[1][v] << " " << sub[v] << endl;
    int old_dp = dp[v], old_sub = sub[v];
    int old_fp0 = fp[0][v];
    int old_fp1 = fp[1][v];


    int how_lose = 0;
    int ls_fp_0 = 0, ls_fp_1 = 0, win_fp_0 = 0, win_fp_1 = 0;
    int sub_lose = 0, sub_win = 0;
    for (int u : adj[v])
    {
        if (dp[u] == 0)
            how_lose ++;

        if (dp[u] == 0)
        {
            ls_fp_0 += fp[0][u];
            ls_fp_1 += fp[1][u];
            sub_lose += sub[u];
        }
        else
        {
            win_fp_0 += fp[0][u];
            win_fp_1 += fp[1][u];
            sub_win += sub[u];
        }
    }

    //cout << "HERE " << ls_fp_0 << " " << ls_fp_1 << " " << win_fp_0 << " " << win_fp_1 << " " << how_lose << endl;
    if (how_lose > 1)
    {
        prec[0][v] = n;
        prec[1][v] = n;
    }
    else
    if (how_lose == 1)
    {
        prec[0][v] = n - ls_fp_0;
        prec[1][v] = n - ls_fp_1;
    }
    else
    {
        prec[1][v] = 1;

        prec[0][v] += sub_win - win_fp_0;
        prec[1][v] += sub_win - win_fp_1;
    }


    
    for (int u : adj[v])
    {
        if (u == p)
            continue;

        how_lose = how_lose - (dp[u] == 0);
        dp[v] = (how_lose > 0);
        sub[v] = n - sub[u];
        
        if (dp[u] == 0)
        {
            ls_fp_0 -= fp[0][u];
            ls_fp_1 -= fp[1][u];
            sub_lose -= sub[u];
        }
        else
        {
            win_fp_0 -= fp[0][u];
            win_fp_1 -= fp[1][u];
            sub_win -= sub[u];
        }

        if (how_lose > 1)
        {
            fp[0][v] = sub[v];
            fp[1][v] = sub[v];
        }
        else
        if (how_lose == 1)
        {
            fp[0][v] = sub[v] - ls_fp_0;
            fp[1][v] = sub[v] - ls_fp_1;
        }
        else
        {
            //cout << "YEP " << v << " -> " << u << endl;
            //cout << "GO " << sub_win << " " << win_fp_0 << " " << win_fp_1 << endl;
            fp[1][v] = 1;
            fp[0][v] = 0;
            fp[0][v] += sub_win - win_fp_0;
            fp[1][v] += sub_win - win_fp_1;
            ///cout << "res " << fp[0][]
        }

        euler(u, v);


        if (dp[u] == 0)
        {
            ls_fp_0 += fp[0][u];
            ls_fp_1 += fp[1][u];
            sub_lose += sub[u];
        }
        else
        {
            win_fp_0 += fp[0][u];
            win_fp_1 += fp[1][u];
            sub_win += sub[u];
        }

        how_lose = how_lose + (dp[u] == 0);
        dp[v] = old_dp;
        fp[0][v] = old_fp0;
        fp[1][v] = old_fp1;
        sub[v] = old_sub;
        
    }

    
}


ll trans[2][2];
void do_math()
{
    ll win_ways = 0, lose_ways = 0;
    for (int i = 1; i <= n; i ++)
        if (state[i] == 1)
            win_ways ++;
        else
            lose_ways ++;

    
    dfs(1, -1);
    euler(1, -1);


    for (int i = 1; i <= n; i ++)
    {
         //dfs(i, - 1);
        //prec[0][i] = fp[0][i];  
        //prec[1][i] = fp[1][i];
        trans[0][0] += prec[0][i];
        trans[1][0] += prec[1][i];
        trans[0][1] += (n - prec[0][i]);
        trans[1][1] += (n - prec[1][i]);

        for (int f = 0; f < 2; f ++)
            for (int c = 0; c < 2; c ++)
            {
                if (trans[f][c] >= mod)
                    trans[f][c] -= mod;
            }

    }

    //for (int i = 1; i <= n; i ++)
    //{
    //    cout << "data " << i << " " << prec[0][i] << " " << prec[1][i] << endl;
   // }
    

    for (int t = 0; t < d - 1; t ++)
    {
        ll new_win = 0, new_lose = 0;
        new_win = trans[0][0] * win_ways + trans[1][0] * lose_ways;
        new_lose = trans[0][1] * win_ways + trans[1][1] * lose_ways;

        new_win %= mod;
        new_lose %= mod;

        win_ways = new_win;
        lose_ways = new_lose;
    }
    ll ways = 0;

       
    ways = ways + (ll)(prec[0][1]) * win_ways + (ll)(prec[1][1]) * lose_ways;
    ways %= mod;
    
    cout << ways << endl;
}
void solve()
{
    input();
    get_states();
    do_math();

}
int main()
{
    solve();
    return 0;
}
    

/**
3 2
1 2
2 3

20
*/