#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n, m;
int beg[150005], wnt[150005];
bool fl[150005], used[150005], big_ans;

vector<int> spis_beg[150005], spis_wnt[150005];
vector<pair<int, int> > segm[600005];

int hpcv[150005];
int par[150005], dpt[150005];

void update(int v, int le, int ri, int be, int en, int u1, int v1)
{
    if(le>en || ri<be) return;
    if(be<=le && ri<=en)
    {
        segm[v].push_back({u1, v1});
        return;
    }
    int mid=(le+ri)/2;
    update(2*v, le, mid, be, en, u1, v1);
    update(2*v+1, mid+1, ri, be, en, u1, v1);
}

void solve_tree(int v, int le, int ri)
{
    vector<pair<int, int> > prom_p;
    vector<pair<int, int> > prom_dpt;

    if(!big_ans) return;
    for(int i=0; i<segm[v].size(); i++)
    {
        int vr1=segm[v][i].first, vr2=segm[v][i].second;
        while(vr1!=par[vr1]) vr1=par[vr1];
        while(vr2!=par[vr2]) vr2=par[vr2];
        if(vr1==vr2) continue;
        if(dpt[vr1]<dpt[vr2])
        {
            prom_p.push_back({vr1, par[vr1]});
            par[vr1]=vr2;
        }
        else if(dpt[vr1]>dpt[vr2])
        {
            prom_p.push_back({vr2, par[vr2]});
            par[vr2]=vr1;
        }
        else
        {
            prom_p.push_back({vr1, par[vr1]});
            prom_dpt.push_back({vr2, dpt[vr2]});
            par[vr1]=vr2;
            dpt[vr2]++;
        }
    }

    if(le!=ri)
    {
        solve_tree(2*v, le, (le+ri)/2);
        solve_tree(2*v+1, (le+ri)/2+1, ri);
    }
    else
    {
        int cv=le;
        for(int i=0; i<spis_beg[cv].size(); i++)
        {
            int hpi=spis_beg[cv][i];
            while(hpi!=par[hpi]) hpi=par[hpi];
            hpcv[hpi]=cv;
        }
        for(int i=0; i<spis_wnt[cv].size(); i++)
        {
            int hpi=spis_wnt[cv][i];
            while(hpi!=par[hpi]) hpi=par[hpi];
            if(hpcv[hpi]!=cv)
            {
                big_ans=0;
                return;
            }
        }
    }

    for(int i=prom_p.size()-1; i>=0; i--)
    {
        par[prom_p[i].first]=prom_p[i].second;
    }
    for(int i=prom_dpt.size()-1; i>=0; i--)
    {
        dpt[prom_dpt[i].first]=prom_dpt[i].second;
    }
}

int solve()
{
    cin>>n>>m;
    big_ans=1;
    for(int i=1; i<=4*n; i++) segm[i].resize(0);
    for(int i=1; i<=n; i++)
    {
        hpcv[i]=0;
        par[i]=i;
        dpt[i]=1;
        fl[i]=0;
        spis_beg[i].resize(0);
        spis_wnt[i].resize(0);
    }

    for(int i=1; i<=n; i++) 
    {
        cin>>beg[i];
        spis_beg[beg[i]].push_back(i);
    }
    for(int i=1; i<=n; i++) 
    {
        cin>>wnt[i];
        spis_wnt[wnt[i]].push_back(i);
    }
    for(int i=0; i<m; i++)
    {
        int u, v;
        cin>>u>>v;
        int le=max(wnt[u], wnt[v]);
        int ri=min(beg[u], beg[v]);
        if(ri<le) continue;
        update(1, 1, n, le, ri, u, v);
    }
    for(int i=1; i<=n; i++) if(beg[i]<wnt[i]) return 0;
    solve_tree(1, 1, n);

    return big_ans;

}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin>>t;
    while(t--) cout<<solve()<<endl;
    return 0;
}