#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=150005;

int n,m;
int c[MAXN];
int d[MAXN];
vector<int> adj[MAXN];
int a[MAXN];
int last[MAXN];
int prv[MAXN];
int nxt[MAXN];
vector<int> pos[MAXN];
int treeS[MAXN];
int tree[4*MAXN];

void update(int ind,int val)
{
    while(ind<=n)
    {
        treeS[ind]+=val;
        ind+=ind&(-ind);
    }
}

int query(int ind)
{
    int ret=0;
    while(ind>0)
    {
        ret+=treeS[ind];
        ind-=ind&(-ind);
    }
    return ret;
}

int query(int l,int r)
{
    return query(r)-query(l-1);
}

void build(int node,int l,int r)
{
    if(l==r)
    {
        tree[node]=c[a[l]];
        return;
    }
    int mid=(l+r)/2;
    build(2*node,l,mid);
    build(2*node+1,mid+1,r);
    tree[node]=min(tree[2*node], tree[2*node+1]);
}

int queryMin(int node,int l,int r,int b,int e)
{
    if(b<=l && r<=e) return tree[node];
    int mid=(l+r)/2;
    int ret=n+1;
    if(b<=mid) ret=min(ret, queryMin(2*node,l,mid,b,e));
    if(mid<e) ret=min(ret, queryMin(2*node+1,mid+1,r,b,e));
    return ret;
}

int queryMin(int l,int r)
{
    return queryMin(1,1,n,l,r);
}

void init()
{
    for(int i=1;i<=n;i++) adj[i].clear();
    for(int i=1;i<=n;i++) pos[i].clear();
    for(int i=1;i<=n;i++) treeS[i]=0;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int tt;
cin>>tt;
while(tt--)
{
    cin>>n>>m; init();
    for(int i=1;i<=n;i++) cin>>c[i];
    for(int i=1;i<=n;i++) cin>>d[i];
    for(int i=0;i<m;i++)
    {
        int u,v;
        cin>>u>>v;
        adj[u].push_back(v);
        adj[v].push_back(u);
    }

    bool fl=0;
    for(int i=1;i<=n;i++)
    {
        if(d[i]>c[i])
        {
            cout<<0<<endl;
            fl=1;
            break;
        }
    }
    if(fl) continue;
    if(n==1)
    {
        if(d[1]!=c[1]) cout<<0<<endl;
        else cout<<1<<endl;
        continue;
    }

    int r=1;
    for(int i=1;i<=n;i++)
    {
        if(adj[i].size()==1)
        {
            r=i;
            break;
        }
    }
    a[1]=r;
    a[2]=adj[r][0];
    for(int i=3;i<=n;i++)
    {
        int u=0,v=0;
        u=adj[a[i-1]][0];
        v=adj[a[i-1]][1];
        if(u!=a[i-2]) a[i]=u;
        else a[i]=v;
    }
    //for(int i=1;i<=n;i++) cout<<a[i]<<" "; cout<<endl;

    for(int i=1;i<=n;i++) last[i]=0;
    for(int i=1;i<=n;i++)
    {
        prv[i]=last[d[a[i]]];
        last[c[a[i]]]=i;
    }
    for(int i=1;i<=n;i++) last[i]=n+1;
    for(int i=n;i>0;i--)
    {
        nxt[i]=last[d[a[i]]];
        last[c[a[i]]]=i;
    }

    for(int i=1;i<=n;i++)
    {
        pos[d[a[i]]].push_back(i);
    }

    build(1,1,n);

    fl=0;
    for(int i=n;i>0;i--)
    {
        //cout<<i<<" "<<pos[i].size()<<endl;
        for(int j=0;j<pos[i].size();j++)
        {
            int cur=pos[i][j];
            if(c[a[cur]]==d[a[cur]]) continue; //cout<<cur<<prv[cur]<<nxt[cur]<<endl;
            if(prv[cur]>0)
            {
                if(query(prv[cur],cur)==0 && queryMin(prv[cur],cur)>=i) continue;
            }
            if(nxt[cur]<=n)
            {//cout<<query(cur,nxt[cur])<<" "<<queryMin(cur,nxt[cur])<<endl;
                if(query(cur,nxt[cur])==0 && queryMin(cur,nxt[cur])>=i) continue;
            }
            fl=1;
        }
        if(fl) break;
        for(int j=0;j<pos[i].size();j++)
        {
            update(pos[i][j],1);
        }
    }
    if(fl) cout<<0<<endl;
    else cout<<1<<endl;
}

return 0;
}
/*
1
6 5
4 1 6 5 5 3
1 1 5 3 3 3
1 2
2 3
3 4
4 5
5 6
*/
