#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const int maxn = 3e5+5;

int n,m,c[maxn],d[maxn];
vector<int>g[maxn];

int used[maxn];

void pre()
{
    for(int i = 1; i <= n; i++) g[i].clear();
    for(int i = 1; i <= n; i++) used[i] = 0;
}

int cl[maxn],cr[maxn];
int dl[maxn],dr[maxn];

void solve()
{
    c[0] = c[n+1] = 0;
    d[0] = d[n+1] = 1e9;

    for(int i = 1; i <= n; i++)
    {
        dl[i] = dr[i] = i;
        int pl = i;
        while(pl>=1&&c[pl]>=c[i]&&d[pl]<=d[i]) pl--;
        int pr = i;
        while(pr<=n&&c[pr]>=c[i]&&d[pr]<=d[i]) pr++;
        dl[i] = pl;
        dr[i] = pr;
    }

    for(int i = 1; i <= n; i++)
    {
        bool f = false;
        for(int j = 1; j <= n; j++)
        {
            if(d[i]==c[j] && dl[j]<i&&i<dr[j])
            {
                f = true;
                break;
            }
        }
        if(!f)
        {
            cout << 0 << endl;
            return;
        }
    }
    cout << 1 << endl;
}

int opr[maxn],opc[maxn],opd[maxn];

void dfs_opr(int beg, int par, int pos)
{
    opr[pos] = beg;
    if(pos==n) return;
    for(int nb : g[beg]) if(nb!=par) dfs_opr(nb,beg,pos+1);
}

void read()
{
    cin >> n >> m;
    pre();

    for(int i = 1; i <= n; i++) cin >> c[i];
    for(int i = 1; i <= n; i++) cin >> d[i];
    int x,y;
    for(int i = 1; i <= m; i++)
    {
        cin >> x >> y;
        g[x].push_back(y);
        g[y].push_back(x);
    }

    bool f = true;
    for(int i = 1; i <= n; i++) if(c[i]<d[i]) f = false;
    for(int i = 1; i <= n; i++) used[c[i]] = 1;
    for(int i = 1; i <= n; i++) if(!used[d[i]]) f = false;

    if(!f)
    {
        cout << f << endl;
        return;
    }

    for(int i = 1; i <= n; i++)
    {
        if(g[i].size()==1)
        {
            dfs_opr(i,i,1);
            break;
        }
    }

    for(int i = 1; i <= n; i++)
    {
        opc[i] = c[opr[i]];
        opd[i] = d[opr[i]];
    }
    for(int i = 1; i <= n; i++)
    {
        c[i] = opc[i];
        d[i] = opd[i];
    }
    solve();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int t;
	cin >> t;
	while(t--) read();
return 0;
}
