#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1e9+7;
const int maxn = 2e5+5;

long long n,d;
vector<int>g[maxn];

void read()
{
    cin >> n >> d;
    int a,b;
    for(int i = 1; i < n; i++)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
        g[a+n].push_back(b+n);
        g[b+n].push_back(a+n);
    }
}

bool dp[maxn];

void dfs_dp(int beg, int par)
{
    dp[beg] = 0;
    for(int nb : g[beg])
    {
        if(nb==par) continue;
        dfs_dp(nb,beg);
        if(!dp[nb]) dp[beg] = true;
    }
}

void solve()
{
    long long ans = 0;
    for(int i = 1; i <= n; i++)
    {
        for(int j = 1; j <= n; j++)
        {
            g[i].push_back(j+n);
            g[j+n].push_back(i);
            dfs_dp(1,1);
            if(dp[1]) ans++;
            g[i].pop_back();
            g[j+n].pop_back();
        }
    }
    cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	read();
	solve();
return 0;
}
