#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1e9+7;
const int maxn = 1e5+5;

long long n,d;
vector<int>g[maxn];

int sub[maxn],jump[maxn][20];

void dfs_sub(int beg, int par)
{
    sub[beg] = sub[par] + 1;
    jump[beg][0] = par;
    for(int nb : g[beg])
    {
        if(nb==par) continue;
        dfs_sub(nb,beg);
    }
}

void pre()
{
    dfs_sub(1,1);
    for(int j = 1; j < 20; j++)
    {
        for(int i = 1; i <= n; i++)
        {
            jump[i][j] = jump[jump[i][j-1]][j-1];
        }
    }
}

int lca(int a, int b)
{
    if(sub[a]<sub[b]) swap(a,b);
    int raz = sub[a] - sub[b];
    for(int j = 19; j >= 0; j--) if(raz&(1<<j)) a = jump[a][j];
    if(a==b) return a;

    for(int j = 19; j >= 0; j--)
    {
        if(jump[a][j] != jump[b][j])
        {
            a = jump[a][j];
            b = jump[b][j];
        }
    }
    return jump[a][0];
}

int dist(int a, int b)
{
    return sub[a] + sub[b] - 2*sub[lca(a,b)];
}

void read()
{
    cin >> n >> d;
    int a,b;
    for(int i = 1; i < n; i++)
    {
        cin >> a >> b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    pre();
}

bool dp[maxn],na[maxn];
bool znach[maxn];

void dfs_dp(int beg, int par)
{
    ///if(beg==n+1) return;
    dp[beg] = 0;
    for(int nb : g[beg])
    {
        if(nb==par) continue;
        dfs_dp(nb,beg);
        if(!dp[nb]) dp[beg] = true;
    }
}

void dfs_na(int beg, int par, bool up)
{
    na[beg] = dp[beg];
    if(!up) na[beg] = true;

    int sum = (1-up);
    for(int nb : g[beg]) if(nb!=par) sum += (1-dp[nb]);

    for(int nb : g[beg])
    {
        if(nb==par) continue;
        bool pom = 0;
        if(sum-(1-dp[nb])) pom = true;
        dfs_na(nb,beg,pom);
    }
}

void dfs_znach(int beg, int par, bool f)
{
    int brd = 0;
    int sum = 0;
    for(int nb : g[beg])
    {
        if(nb!=par)
        {
            sum += dp[nb];
            brd ++;
        }
    }

    znach[beg] = false;
    if(f)
    {
        if(brd==sum) znach[beg] = true;
        if(brd-2>=sum) f = false;
    }

    for(int nb : g[beg])
    {
        if(nb==par) continue;
        if(!f) dfs_znach(nb,beg,f);
        else
        {
            if(sum-dp[nb]==brd-1) dfs_znach(nb,beg,true);
            else dfs_znach(nb,beg,false);
        }
    }
}

long long sluch[2];

void solve()
{
    dfs_dp(1,1);
    dfs_na(1,1,1);
    dfs_znach(1,1,1);
    for(int i = 1; i <= n; i++) sluch[na[i]]++;

    dfs_dp(1,1);
    long long ans = 0;

    for(int i = 1; i <= n; i++)
    {
        if(!znach[i])
        {
            if(dp[1]) ans += (sluch[0]+sluch[1]);
        }
        else ans += sluch[dist(i,1)%2];
        ans %= mod;
    }
    cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	read();
	solve();
return 0;
}
