#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long n, d, mod=1e9+7;

long long fast_pow(long long base, long long st)
{
    base%=mod;
    if(st==0) return 1;
    if(st&1) return (base*fast_pow(base, st-1))%mod;
    long long t=fast_pow(base, st/2);
    return t*t%mod;
}


vector<int> gr[100005];
bool used[100005];
int par[100005];
long long tpos[100005], sumpval[100005], sumgval[100005];

void dfs(int v)
{
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(nv==par[v]) continue;
        par[nv]=v;
        dfs(nv);
        if(!tpos[nv]) tpos[v]++;
    }

    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(nv==par[v]) continue;
        if(tpos[nv]==1) sumpval[v]+=sumgval[nv];
        else if(tpos[nv]==0) sumgval[v]+=sumpval[nv];
    }
    if(tpos[v]==0) sumpval[v]++;
}

long long sumpechpos=0, sumgubpos=0;
long long brpechpos=0, brgubpos=0;

void dfs2(int v)
{
    used[v]=1;
    if(!tpos[v]) 
    {
        brgubpos++; 
        sumgubpos+=sumpval[v];
    }
    else 
    {
        brpechpos++; 
        if(tpos[v]==1) sumpechpos+=sumgval[v];
    }
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i];
        if(used[nv]) continue;
        
        long long v_sumgval=sumgval[v], v_tpos=tpos[v], v_sumpval=sumpval[v];
        long long nv_sumgval=sumgval[nv], nv_tpos=tpos[nv], nv_sumpval=sumpval[nv];
        if(!tpos[nv]) 
        {
            tpos[v]--;
            sumgval[v]-=sumpval[nv];
        }
        else if(tpos[nv]==1)
        {
            sumpval[v]-=sumgval[nv];
        }
        if(!tpos[v]) {tpos[nv]++; if(v_tpos) sumpval[v]++;}

        if(tpos[v]==1) sumpval[nv]+=sumgval[v];
        else if(tpos[v]==0) sumgval[nv]+=sumpval[v];
        if(nv_tpos && !tpos[nv]) sumpval[nv]++;
        
        dfs2(nv);
        sumgval[v]=v_sumgval, tpos[v]=v_tpos, sumpval[v]=v_sumpval;
        sumgval[nv]=nv_sumgval, tpos[nv]=nv_tpos, sumpval[nv]=nv_sumpval;
    }
}

long long matr[5][5];
long long matr2[5][5], matr3[5][5];

void pow_matr(long long st)
{
    st%=(mod-1);
    for(int i=0; i<5; i++)
        for(int j=0; j<5; j++)
        {
            matr2[i][j]=matr[i][j];
            matr3[i][j]=0;
            if(i==j) matr[i][j]=1;
            else matr[i][j]=0;
        }
    while(st)
    {
        if(st&1)
        {
            for(int i=0; i<5; i++)
            {
                for(int j=0; j<5; j++)
                {
                    for(int k=0; k<5; k++)
                    {
                        matr3[i][j]+=matr[i][k]*matr2[k][j];
                        matr3[i][j]%=mod;
                    }
                }
            }
            for(int i=0; i<5; i++)
            {
                for(int j=0; j<5; j++)
                {
                    matr[i][j]=matr3[i][j];
                    matr3[i][j]=0;
                }
            }
        }
        st>>=1;
        for(int i=0; i<5; i++)
        {
            for(int j=0; j<5; j++)
            {
                for(int k=0; k<5; k++)
                {
                    matr3[i][j]+=matr2[i][k]*matr2[k][j];
                    matr3[i][j]%=mod;
                }
            }
        }
        for(int i=0; i<5; i++)
        {
            for(int j=0; j<5; j++)
            {
                matr2[i][j]=matr3[i][j];
                matr3[i][j]=0;
            }
        }
    }
}



void solve()
{
    for(int i=0; i<n-1; i++)
    {
        int v1, v2;
        cin>>v1>>v2;
        gr[v1].push_back(v2);
        gr[v2].push_back(v1);
    }
    dfs(1);
    dfs2(1);
    matr[0][4]=brpechpos*n-sumpechpos;
    matr[3][4]=brgubpos*n-sumgubpos;
    matr[0][0]=sumpechpos;
    matr[0][1]=sumpechpos;
    matr[1][2]=sumgubpos;
    matr[1][3]=sumgubpos;
    matr[2][2]=sumpechpos;
    matr[2][3]=sumpechpos;
    matr[3][0]=sumgubpos;
    matr[3][1]=sumgubpos;
    for(int i=0; i<5; i++)
    {
        for(int j=0; j<5; j++) matr[i][j]%=mod;
    }
    brpechpos%=mod;
    brgubpos%=mod;
    sumpechpos%=mod;
    sumgubpos%=mod;
    pow_matr(d-1);
    if(tpos[1]>=2) cout<<fast_pow(n*n, d)%mod<<endl;    
    else if(tpos[1]==1)
    {
        long long brpob=0;
        brpob+=((n-sumgval[1])*n%mod)*fast_pow(n*n, d-1)%mod;
        long long sum=sumgval[1]*((matr[0][4]+matr[1][4])*n%mod+((matr[0][0]+matr[1][0])*brpechpos%mod+(matr[0][3]+matr[1][3])*brgubpos%mod))%mod;
        cout<<(sum+brpob)%mod<<endl;
    }
    else
    {
        long long sum=sumpval[1]*((matr[2][4]+matr[3][4])*n%mod+((matr[2][0]+matr[3][0])*brpechpos%mod+(matr[2][3]+matr[3][3])*brgubpos%mod))%mod;
        cout<<sum%mod<<endl;
    }
}


int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>d;
    solve();
    return 0;
}