#include<bits/stdc++.h>
using namespace std;

vector<int> haha[150001];
vector<int> c(150001);
vector<int> d(150001);
vector<int> ans(150001);
vector<int> dsu(150001);
vector<int> seg[700000];
vector<int> apple[150001];
vector<int> banana[150001];
vector<pair<int,int>> roll[20];

int calc(int a, int dep) {
    int c = a;
    while(dsu[c] != c) {
        c = dsu[c];
    }
    int e = a;
    return c;
}

void edge(int a, int b, int dep) {
    a = calc(a,dep);
    b = calc(b,dep);
    if(a != b) {
        roll[dep].push_back({a,dsu[a]});
        dsu[a] = b;
    }
}

void dude(int l, int r, int ql, int qr, int p, int x) {
    if(ql == l && qr == r) {
        seg[x].push_back(p);
        return;
    }
    int m = (l+r)/2;
    if(qr <= m) {
        dude(l,m,ql,qr,p,x*2);
    }
    else if(ql > m) {
        dude(m+1,r,ql,qr,p,x*2+1);
    }
    else {
        dude(l,m,ql,m,p,x*2);
        dude(m+1,r,m+1,qr,p,x*2+1);
    }
}

vector<int> no(150001,-1);

void troll(int l, int r, int x, int dep)  {
    for(int v: seg[x]) {
        for(int u: haha[v]) {
            if(d[u] <= l && c[u] >= r) {
                edge(u,v,dep);
            }
        }
    }
    if(l == r) {
        for(int v: apple[l]) {
            no[calc(v,dep)] = x;
        }
        for(int v: banana[l]) {
            if(no[calc(v,dep)] == x) {
                ans[v] = 1;
            }
        }
    }
    else {
        int m = (l+r)/2;
        troll(l,m,x*2,dep+1);
        troll(m+1,r,x*2+1,dep+1);
    }
    for(int i = (int)roll[dep].size()-1; i >= 0; i--) {
         dsu[roll[dep][i].first] = roll[dep][i].second;
    }
    roll[dep].clear();
}

void solve() {
    int n,m,a,b;
    cin >> n >> m;
    for(int i = 1; i <= n; i++) {
        haha[i].clear();
        ans[i] = 0;
        dsu[i] = i;
        apple[i].clear();
        banana[i].clear();
    }
    for(int i = 1; i <= 4*n+10; i++) {
        seg[i].clear();
    }
    vector<pair<int,int>> wut(0);
    for(int i = 1; i <= n; i++) {
        cin >> c[i];
        apple[c[i]].push_back(i);
        wut.push_back({c[i],i});
    }
    sort(wut.begin(),wut.end());
    for(int i = 1; i <= n; i++) {
        cin >> d[i];
        banana[d[i]].push_back(i);
    }
    for(int i = 0; i < m; i++) {
        cin >> a >> b;
        haha[a].push_back(b);
        haha[b].push_back(a);
    }
    for(int i = 1; i <= n; i++) {
        if(d[i] > c[i]) {
            cout << 0 << "\n";
            return;
        }
        dude(1,n,d[i],c[i],i,1);
    }
    troll(1,n,1,0);
    for(int i = 1; i <= n; i++) {
        if(ans[i] == 0) {
            cout << 0 << "\n";
            return;
        }
    }
    cout << 1 << "\n";
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    while(t--) {
        solve();
    }
    return 0;
}