#include<iostream>
#include<vector>
#include<set>

#include "magic.cpp"

using namespace std;
static const int MAXT=60000;
static const int MAXN=1300000;
static vector <int> cards;

extern pair <int, int> assistant1 (vector <int>&);
extern pair <int, int> assistant2 (vector <int>&);
extern int magician (int, pair <int, int>, pair <int, int>);
int main () {
    int t;
    cin >> t ;
    for (int i=0; i<t; i++) {
        int n;
        cin >> n ;
        long long int sum=n*1LL*(2*n+1);
        cards.resize(n);
        set <int> nums;
        for (int j=0; j<n; j++) {
            cin >> cards[j] ;
            sum-=cards[j];
            nums.insert(cards[j]);
        }
        auto chosen1=assistant1(cards);
        cout << "Chosen cards from first assistant: " << chosen1.first << " " << chosen1.second << ".\n";
        if ((chosen1.first<0)||(chosen1.first>2*n)||(chosen1.second<0)||(chosen1.second>2*n)) cout << "Invalid cards from assistant!\n";
        if (chosen1.first==chosen1.second) cout << "Identical cards from assistant!\n";
        if ((nums.count(chosen1.first)==0)||(nums.count(chosen1.second)==0)) cout << "Cards from assistant not among received ones!\n";

        nums.clear();
        for (int j=0; j<n; j++) {
            cin >> cards[j] ;
            sum-=cards[j];
            nums.insert(cards[j]);
        }
        auto chosen2=assistant2(cards);
        cout << "Chosen cards from second assistant: " << chosen2.first << " " << chosen2.second << ".\n";
        if ((chosen2.first<0)||(chosen2.first>2*n)||(chosen2.second<0)||(chosen2.second>2*n)) cout << "Invalid cards from assistant!\n";
        if (chosen2.first==chosen2.second) cout << "Identical cards from assistant!\n";
        if ((nums.count(chosen2.first)==0)||(nums.count(chosen2.second)==0)) cout << "Cards from assistant not among received ones!\n";

        auto card=magician(n,chosen1,chosen2);
        if (card==sum) cout << "Correctly guessed card " << card << "!\n";
        else {
            if ((card<0)||(card>2*n)) cout << "Incorrect missing card!\n";
            else cout << "Incorrect missing card! Card: " << sum << ", guess: " << card << ".\n";
        }
    }
    return 0;
}
