#include<bits/stdc++.h>
#define MAXN 150007
using namespace std;

int t,n,a,b;
long long m;
pair<int,int> c[MAXN],d[MAXN];
vector<int> v[MAXN],color[MAXN],dest[MAXN];
bool ban[MAXN];
int li[MAXN],tim;

void reset(){
    for(int i=1;i<=n;i++){
        ban[i]=true;
        v[i].clear();

        dest[i].clear();
        color[i].clear();
    }
}

bool dfs(int x,int y){
    if(x==y)return true;

    li[x]=tim;
    for(int i=0;i<v[x].size();i++){
        if(li[v[x][i]]==tim or ban[v[x][i]])continue;

        if(dfs(v[x][i],y))return true;
    }

    return false;
}

bool path(int x,int y){
    tim++;

    return dfs(x,y);
}

void dfs2(int x){
    li[x]=tim;
    
    for(int i:v[x]){
        if(li[i]==tim or ban[i])continue;
        dfs2(i);
    }
}

void solve(){
    cin>>n>>m;

    reset();

    for(int i=1;i<=n;i++){
        cin>>c[i].first;
        c[i].second=i;

        color[c[i].first].push_back(i);
    }
    for(int i=1;i<=n;i++){
        cin>>d[i].first;
        d[i].second=i;

        dest[d[i].first].push_back(i);
    }

    sort(c+1,c+n+1);
    sort(d+1,d+n+1);

    for(int i=1;i<=m;i++){
        cin>>a>>b;
        v[a].push_back(b);
        v[b].push_back(a);
    }

    int pt=n;
    for(int i=n;i>=1;i--){
        while(pt>=1 and c[pt].first>=d[i].first){
            ban[c[pt].second]=false; pt--;
        }

        long long sz1=dest[d[i].first].size(),sz2=color[d[i].first].size();

        if( sz1 * sz2 > m and false ){

            tim++;
            for(int k:color[d[i].first]){
                if(li[k]!=tim)dfs2(k);
            }

            for(int f:dest[d[i].first]){
                if(li[f]!=tim){
                    cout<<0<<"\n";
                    return;
                }
            }

        }else{
            for(int f:dest[d[i].first]){
                bool dali=false;

                for(int k:color[d[i].first]){
                    if(path(k,f)){
                        dali=true; break;
                    }
                }

                if(!dali){
                    cout<<0<<"\n";
                    return;
                }
            }
        }

        for(int f=i;f>=1 and d[f].first==d[i].first;f--){
            ban[d[f].second]=true;
            i=f;
        }
    }

    cout<<1<<"\n";
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>t;
    for(int i=1;i<=t;i++){
        solve();
    }

    return 0;
}