#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=1e5+5;
const int MOD=1e9+7;

int n;
long long d;
vector<int> adj[MAXN];
int cnt[2];
int win[MAXN];
int subtr[MAXN];
int ch0[MAXN];

int fastPow(long long x,long long pw)
{
    long long ret=1;
    while(pw)
    {
        if(pw&1) ret=ret*x%MOD;
        x=x*x%MOD;
        pw/=2;
    }
    return ret;
}

void dfs1(int v,int par)
{
    win[v]=0;
    subtr[v]=1;
    ch0[v]=0;
    for(auto u: adj[v])
    {
        if(u==par) continue;
        dfs1(u,v);
        if(win[u]==0)
        {
            win[v]=1;
            ch0[v]++;
        }
        subtr[v]+=subtr[u];
    }
}

void dfs12(int v,int par)
{
    int parWin=0;
    for(auto u: adj[v])
    {
        if(u==par) continue;

        if(win[v]==0) parWin=0;
        else
        {
            parWin=1;
            if(ch0[v]<=1 && win[u]==0) parWin=0;
        }
        if(parWin==0)
        {
            ch0[u]++;
            if(ch0[u]>0) win[u]=1;
        }
        cnt[win[u]]++;

        dfs12(u,v);

        /*if(parWin==0)
        {
            ch0[u]--;
            if(ch0[u]<1) win[u]=0;
        }*/
    }
}

int dfs3(int v,int par)
{
    int ret=cnt[0];
    for(auto u: adj[v])
    {
        if(u==par) continue;
        if(ch0[u]>=2) continue;
        for(auto t: adj[u])
        {
            if(t==v) continue;
            if(win[t]==0) ret+=dfs3(t,u);
        }
    }
    return ret;
}

int dfs2(int v,int par)
{
    int cur=0;
    for(auto u: adj[v])
    {
        if(u==par) continue;
        if(win[u]==0) cur++;
    }
    if(cur>=2) return n*n;

    int ret=0;
    for(auto u: adj[v])
    {
        if(u==par) continue;
        if(win[u]==0)
        {
            ret+=n*n-dfs3(u,v);
            return ret;
        }
    }
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>d;
for(int i=1;i<n;i++)
{
    int u,v;
    cin>>u>>v;
    adj[u].push_back(v);
    adj[v].push_back(u);
}

if(n==2)
{
    cout<<fastPow(4,d)<<endl;
    return 0;
}
/*
for(int i=1;i<=n;i++)
{
    dfs1(i,0);
    if(win[i]) cnt1++;
    else cnt0++;
}*/

dfs1(1,0);
cnt[win[1]]++;
dfs12(1,0);

//cout<<cnt[1]<<cnt[0]<<endl;

int ans=0;
for(int i=1;i<=1;i++)
{
    dfs1(i,0);
    if(win[i]==1) ans+=dfs2(i,0);
    else ans+=dfs3(i,0);
    if(ans>=MOD) ans-=MOD;
}

cout<<ans<<endl;

return 0;
}
