#include<iostream>
#include<vector>
using namespace std;
pair <int, int> assistant1 (vector <int>& cards){
    int sum=0;
    int n=cards.size()*2+1;
    bitset<1300010> used;
    for(auto x: cards){
        sum+=x;
        sum%=n;
        used[x]=true;
    }
    for(auto x: cards){
        int y=sum-x;
        if(y<0) y+=n;
        if(used[y]){
            if(x<y) return {x,y};
            else return {y,x};
        }
    }
    sum=n-sum;
    for(auto x: cards){
        int y=sum-x;
        if(y<0) y+=n;
        if(used[y]){
            if(x>y) return {x,y};
            else return {y,x};
        }
    }
}

pair <int, int> assistant2 (vector <int>& cards){
    int sum=0;
    int n=cards.size()*2+1;
    bitset<1300010> used;
    for(auto x: cards){
        sum+=x;
        sum%=n;
        used[x]=true;
    }
    for(auto x: cards){
        int y=sum-x;
        if(y<0) y+=n;
        if(used[y]){
            if(x<y) return {x,y};
            else return {y,x};
        }
    }
    sum=n-sum;
    for(auto x: cards){
        int y=sum-x;
        if(y<0) y+=n;
        if(used[y]){
            if(x>y) return {x,y};
            else return {y,x};
        }
    }
}

int magician (int N, pair <int, int> chosen1, pair <int, int> chosen2){
    N=2*N+1;
    int s1=chosen1.first+chosen1.second;
    int s2=chosen2.first+chosen2.second;
    if(chosen1.first>chosen1.second) s1=N-s1;
    if(chosen2.first>chosen2.second) s2=N-s2;
    return N-(s1+s2)%N;
}
